import {
  select,
  schemeCategory10,
  csvParse,
  min,
  max,
  extent,
  group,
  flatGroup,
  rollup,
  flatRollup,
  sum,
  bin,
  timeFormat,
} from 'd3';
import { menu } from './menu.js';

export const viz = (
  container,
  { state, setState }
) => {

  // state.data could be:
  // * undefined
  // * 'LOADING'
  // * An array of objects
  const { data } = state;

  if (!data) {
    setState((state) => ({
      ...state,
      data: 'LOADING',
    }));

    fetch('data.csv')
      .then((response) => response.text())
      .then((csvString) => {
        const data = csvParse(csvString);
        setState((state) => ({
          ...state,
          data,
          value: 'Select',
        }));
      });
  } else if (data && data !== 'LOADING') {
    select(container).call(menu, {
      data,
      value: state.value,
      onChange: (value) => {
        setState((state) => ({
          ...state,
          value,
        }));
      },
    });
  }
};
